%define _localstatedir %_var
%def_enable libcryptsetup


Name: systemd
Version: 20
Release: alt3
Summary: A System and Session Manager
Url: http://www.freedesktop.org/wiki/Software/systemd
Group: System/Configuration/Boot and Init
License: GPLv2+

%define udev_ver 160
%define dbus_ver 1.3.2

BuildRequires: libudev-devel >= %udev_ver
BuildRequires: libcap-devel
BuildRequires: libwrap-devel
BuildRequires: libpam-devel
BuildRequires: xsltproc
BuildRequires: docbook-style-xsl docbook-dtds
BuildRequires: libdbus-devel >= %dbus_ver
BuildRequires: libselinux-devel
BuildRequires: libaudit-devel
BuildRequires: vala >= 0.10
BuildRequires: libgtk+2-devel
BuildRequires: glib2-devel >= 2.26 libgio-devel
BuildRequires: libnotify-devel
%{?_enable_libcryptsetup:BuildRequires: libcryptsetup-devel}
Requires: systemd-units = %version-%release
Requires: dbus >= %dbus_ver
Requires: udev >= %udev_ver
# Requires: selinux-policy >= 3.8.5
Source:%name-%version.tar
Source2: rc-local.service
Source3: sysinit.service
Source4: prefdm.service
Source5: altlinux-loadmodules.service
Source6: altlinux-idetune.service
Source7: altlinux-update_chrooted.service
Source8: altlinux-clock-setup.service
Source9: modules.conf
Source10: altlinux-swap.service
Source11: altlinux-storage-init
Source12: altlinux-storage-init.service
Source13: altlinux-wait-storage.service
Source14: systemctl-bash3
Source15: network.service

Patch: %name-snapshot.patch
Patch2: %name-alt-patches.patch
Patch3: %name-%version-fsck.patch

%description
systemd is a system and session manager for Linux, compatible with
SysV and LSB init scripts. systemd provides aggressive parallelization
capabilities, uses socket and D-Bus activation for starting services,
offers on-demand starting of daemons, keeps track of processes using
Linux cgroups, supports snapshotting and restoring of the system
state, maintains mount and automount points and implements an
elaborate transactional dependency-based service control logic. It can
work as a drop-in replacement for sysvinit.

%package units
Group: System/Configuration/Boot and Init
Summary: Configuration files, directories and installation tool for systemd
# Copy from SysVinit
PreReq: coreutils
Requires: /sbin/sulogin
Requires: sysvinit-utils

%description units
Basic configuration files, directories and installation tool for the systemd
system and session manager.

%package gtk
Group: System/Configuration/Boot and Init
Summary: Graphical frontend for systemd
Requires: %name = %version-%release

%description gtk
Graphical front-end for systemd.

%package sysvinit
Group: System/Configuration/Boot and Init
Summary: systemd System V init tools
Requires: %name = %version-%release
# Obsoletes: SysVinit
Provides: SysVinit = 2.88-alt0.1
#Obsoletes:      upstart
Conflicts: upstart
Conflicts: SysVinit

%description sysvinit
Drop-in replacement for the System V init tools of systemd.

%prep
%setup -q
%patch -p1
%patch2 -p1

%build
%autoreconf
%configure --with-rootdir= --with-distro=altlinux %{subst_enable libcryptsetup}

%make_build

%install
%make DESTDIR=%buildroot install
install -m644 %SOURCE2 %buildroot/lib/systemd/system/rc-local.service
ln -s rc-local.service %buildroot/lib/systemd/system/local.service
#install -m644 %SOURCE3 %buildroot/lib/systemd/system/sysinit.service
#ln -s ../sysinit.service %buildroot/lib/systemd/system/sysinit.target.wants/sysinit.service
install -m644 %SOURCE4 %buildroot/lib/systemd/system/prefdm.service
ln -s prefdm.service %buildroot/lib/systemd/system/dm.service
ln -s prefdm.service %buildroot/lib/systemd/system/display-manager.service
ln -s ../display-manager.service %buildroot/lib/systemd/system/graphical.target.wants/display-manager.service
install -m644 %SOURCE5 %buildroot/lib/systemd/system/altlinux-loadmodules.service
ln -s ../altlinux-loadmodules.service %buildroot/lib/systemd/system/sysinit.target.wants/altlinux-loadmodules.service
install -m644 %SOURCE6 %buildroot/lib/systemd/system/altlinux-idetune.service
ln -s ../altlinux-idetune.service %buildroot/lib/systemd/system/sysinit.target.wants/altlinux-idetune.service
install -m644 %SOURCE7 %buildroot/lib/systemd/system/altlinux-update_chrooted.service
ln -s ../altlinux-update_chrooted.service %buildroot/lib/systemd/system/multi-user.target.wants/altlinux-update_chrooted.service
install -m644 %SOURCE8 %buildroot/lib/systemd/system/altlinux-clock-setup.service
ln -s ../altlinux-clock-setup.service %buildroot/lib/systemd/system/sysinit.target.wants/altlinux-clock-setup.service
ln -s altlinux-clock-setup.service %buildroot/lib/systemd/system/clock.service
rm -f %buildroot/lib/systemd/system/shutdown.target.wants/hwclock-save.service
install -m644 %SOURCE10 %buildroot/lib/systemd/system/altlinux-swap.service
ln -s ../altlinux-swap.service %buildroot/lib/systemd/system/sysinit.target.wants/altlinux-swap.service
install -m755 %SOURCE11 %buildroot/lib/systemd/altlinux-storage-init
install -m644 %SOURCE12 %buildroot/lib/systemd/system/altlinux-storage-init.service
ln -s ../altlinux-storage-init.service %buildroot/lib/systemd/system/local-fs.target.wants/altlinux-storage-init.service
install -m644 %SOURCE13 %buildroot/lib/systemd/system/altlinux-wait-storage.service
ln -s ../altlinux-wait-storage.service %buildroot/lib/systemd/system/local-fs.target.wants/altlinux-wait-storage.service
install -m644 %SOURCE15 %buildroot/lib/systemd/system/network.service
ln -s ../network.service %buildroot/lib/systemd/system/multi-user.target.wants/network.service

ln -s systemd-random-seed-load.service %buildroot/lib/systemd/system/random.service

find %buildroot \( -name '*.a' -o -name '*.la' \) -exec rm {} \;
mkdir -p %buildroot/sbin
ln -s ../bin/systemd %buildroot/sbin/init
ln -s ../bin/systemctl %buildroot/sbin/reboot
ln -s ../bin/systemctl %buildroot/sbin/halt
ln -s ../bin/systemctl %buildroot/sbin/poweroff
ln -s ../bin/systemctl %buildroot/sbin/shutdown
ln -s ../bin/systemctl %buildroot/sbin/telinit
ln -s ../bin/systemctl %buildroot/sbin/runlevel
rm -rf %buildroot%_docdir/systemd

# add defaults services
ln -s ../rc-local.service %buildroot/lib/systemd/system/multi-user.target.wants/rc-local.service
ln -s ../remote-fs.target %buildroot/lib/systemd/system/multi-user.target.wants/remote-fs.target
ln -s ../quotacheck.service %buildroot/lib/systemd/system/local-fs.target.wants/quotacheck.service
ln -s ../quotaon.service %buildroot/lib/systemd/system/local-fs.target.wants/quotaon.service
mkdir -p %buildroot/lib/systemd/system/getty.target.wants
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty1.service
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty2.service
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty3.service
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty4.service
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty5.service
ln -s ../getty@.service %buildroot/lib/systemd/system/getty.target.wants/getty@tty6.service

# Mask legacy stuff
ln -s rescue.service %buildroot/lib/systemd/system/single.service

# disable legacy services
ln -s /dev/null %buildroot/lib/systemd/system/fbsetfont.service
ln -s /dev/null %buildroot/lib/systemd/system/keytable.service

# Use mingetty as default
%__subst 's,/sbin/agetty,/sbin/mingetty,'  %buildroot/lib/systemd/system/getty@.service

# We create all wants links manually at installation time to make sure
# they are not owned and hence overriden by rpm after the used deleted
# them.
rm -r %buildroot%_sysconfdir/systemd/system/*.target.wants
rm -f %buildroot%_sysconfdir/systemd/system/display-manager.service

# And the default symlink we generate automatically based on inittab
rm -f %buildroot%_sysconfdir/systemd/system/default.target

# Add example file for module load
mkdir -p %buildroot%_sysconfdir/modules-load.d
install -m644 %SOURCE9 %buildroot%_sysconfdir/modules-load.d/modules.conf

# Add completion for bash3
rm -f %buildroot%_sysconfdir/bash_completion.d/*
install -m644 %SOURCE14 %buildroot%_sysconfdir/bash_completion.d/systemctl

# Make sure the ghost-ing below works
touch %buildroot%_sysconfdir/systemd/system/runlevel2.target
touch %buildroot%_sysconfdir/systemd/system/runlevel3.target
touch %buildroot%_sysconfdir/systemd/system/runlevel4.target
touch %buildroot%_sysconfdir/systemd/system/runlevel5.target

touch %buildroot%_sysconfdir/machine-id

# Make sure these directories are properly owned
mkdir -p %buildroot/lib/systemd/system/basic.target.wants
mkdir -p %buildroot/lib/systemd/system/default.target.wants
mkdir -p %buildroot/lib/systemd/system/dbus.target.wants
mkdir -p %buildroot/lib/systemd/system/syslog.target.wants

# The following services are currently executed by rc.sysinit
#pushd %buildroot/lib/systemd/system/basic.target.wants && {
#	rm -f sysctl.service
#	rm -f systemd-modules-load.service
#	rm -f systemd-tmpfiles.service
#	rm -f systemd-tmpfiles-clean.timer
#popd
#}

# The following services are currently installed by initscripts
#pushd %buildroot/lib/systemd/system/graphical.target.wants && {
#	rm -f display-manager.service
#	rm -f dm.service
#popd
#}

# The following services are currently executed by rc.sysinit
#pushd %buildroot/lib/systemd/system/local-fs.target.wants && {
#	rm -f cryptsetup.target
#	rm -f fsck-root.service
#	rm -f remount-rootfs.service
#	rm -f systemd-remount-api-vfs.service
#	rm -f var-lock.mount
#	rm -f var-run.mount
#popd
#}

# ALTLinux not ready for /var/lock and /var/run on tmpfs
pushd %buildroot/lib/systemd/system/local-fs.target.wants && {
	rm -f var-lock.mount
	rm -f var-run.mount
popd
}

# The following services are currently installed by initscripts
#pushd %buildroot/lib/systemd/system/multi-user.target.wants && {
#	rm -f rc-local.service
#	rm -f systemd-ask-password-wall.path
#popd
#}

# plymoth run from initrd
pushd %buildroot/lib/systemd/system/sysinit.target.wants && {
	rm -f plymouth-start.service
popd
}

# The following services are currently executed by rc.sysinit
#pushd %buildroot/lib/systemd/system/sysinit.target.wants && {
#	rm -f systemd-ask-password-console.path
#	rm -f systemd-modules-load.service
#	rm -f systemd-random-seed-load.service
#	rm -f systemd-sysctl.service
#	rm -f systemd-tmpfiles-setup.service
#popd
#}

# The following services are currently part of initscripts
#pushd %buildroot/lib/systemd/system && {
#	rm -f default.target
#	rm -f display-manager.service
#	rm -f prefdm.service
#	rm -f rc-local.service
#	rm -f single.service
#	rm -f sysinit.service
#popd
#}

# disable legacy output to console, it just messes things up
sed -i -e 's/^#SysVConsole=yes$/SysVConsole=no/' \
	%buildroot/etc/systemd/system.conf

# disable swap enable, use altlinux-swap.service
sed -i -e 's/^#SwapAuto=yes$/SwapAuto=no/' \
	%buildroot/etc/systemd/system.conf


%post
/bin/systemd-machine-id-setup > /dev/null 2>&1 || :
/bin/systemctl daemon-reexec > /dev/null 2>&1 || :

%post units
if [ $1 -eq 1 ] ; then
        # Try to read default runlevel from the old inittab if it exists
        runlevel=$(/bin/awk -F ':' '$3 == "initdefault" && $1 !~ "^#" { print $2 }' /etc/inittab 2> /dev/null)
        if [ -z "$runlevel" ] ; then
                target="/lib/systemd/system/graphical.target"
        else
                target="/lib/systemd/system/runlevel$runlevel.target"
        fi

        # And symlink what we found to the new-style default.target
        /bin/ln -sf "$target" %_sysconfdir/systemd/system/default.target 2>&1 || :
fi

%preun units
if [ $1 -eq 0 ] ; then
        /bin/rm -f /etc/systemd/system/default.target > /dev/null 2>&1 || :
fi

%postun units
if [ $1 -ge 1 ] ; then
        /bin/systemctl daemon-reload > /dev/null 2>&1 || :
fi

%files
%config(noreplace) %_sysconfdir/dbus-1/system.d/org.freedesktop.systemd1.conf
%config(noreplace) %_sysconfdir/systemd/system.conf
%dir %_sysconfdir/modules-load.d
%config(noreplace) %verify(not md5 size mtime) %_sysconfdir/modules-load.d/*.conf
# %%_sysconfdir/rc.d/init.d/reboot
%dir %_sysconfdir/systemd/user
%_sysconfdir/xdg/systemd
%ghost %config(noreplace) %_sysconfdir/machine-id
/bin/systemd
/bin/systemd-notify
/bin/systemd-ask-password
/bin/systemd-tty-ask-password-agent
/bin/systemd-machine-id-setup
/lib/systemd/systemd-*
/lib/systemd/altlinux-storage-init
/lib/udev/rules.d/*.rules
%_bindir/systemd-cgls
/%_lib/security/pam_systemd.so
%_man1dir/systemd.*
%_man1dir/systemd-cgls.*
%_man1dir/systemd-notify.*
%_man3dir/*
%_man5dir/*
%_man7dir/*
%_man8dir/pam_systemd.*
%_datadir/systemd
%_datadir/dbus-1/services/org.freedesktop.systemd1.service
%_datadir/dbus-1/system-services/org.freedesktop.systemd1.service
%_datadir/dbus-1/interfaces/org.freedesktop.systemd1.*.xml
# %_docdir/systemd
%doc DISTRO_PORTING LICENSE README
%if_enabled libcryptsetup
%dir /lib/systemd/system-generators
/lib/systemd/system-generators/systemd-cryptsetup-generator
%endif

%files units
%dir %_sysconfdir/systemd
%dir %_sysconfdir/systemd/system
%dir %_sysconfdir/tmpfiles.d
%_sysconfdir/bash_completion.d/systemctl
%config(noreplace) %_sysconfdir/tmpfiles.d/*.conf
%dir /lib/systemd
/lib/systemd/system
/bin/systemctl
/bin/systemd-tmpfiles
%_man1dir/systemctl.*
%_man8dir/systemd-tmpfiles.*
# %%_datadir/pkgconfig/systemd.pc

# Make sure we don't remove runlevel targets from F14 alpha installs,
# but make sure we don't create then anew.
%ghost %config(noreplace) %_sysconfdir/systemd/system/runlevel2.target
%ghost %config(noreplace) %_sysconfdir/systemd/system/runlevel3.target
%ghost %config(noreplace) %_sysconfdir/systemd/system/runlevel4.target
%ghost %config(noreplace) %_sysconfdir/systemd/system/runlevel5.target

%files gtk
%_bindir/systemadm
%_bindir/systemd-gnome-ask-password-agent
%_datadir/polkit-1/actions/org.freedesktop.systemd1.policy
%_man1dir/systemadm.*

%files sysvinit
/sbin/init
/sbin/reboot
/sbin/halt
/sbin/poweroff
/sbin/shutdown
/sbin/telinit
/sbin/runlevel
%_man1dir/init.*
%_man8dir/halt.*
%_man8dir/reboot.*
%_man8dir/shutdown.*
%_man8dir/poweroff.*
%_man8dir/telinit.*
%_man8dir/runlevel.*

%changelog
* Tue Mar 22 2011 Alexey Shabalin <shaba@altlinux.ru> 20-alt3
- disable legacy services: fbsetfont and keytable

* Mon Mar 21 2011 Alexey Shabalin <shaba@altlinux.ru> 20-alt2
- disable swap enable by systemd, use altlinux-swap.service
- disable "SysVConsole" legacy output to console

* Wed Mar 09 2011 Alexey Shabalin <shaba@altlinux.ru> 20-alt1
- v20

* Fri Mar 04 2011 Alexey Shabalin <shaba@altlinux.ru> 19-alt3.git20110301
- add workaround Conflicts: SysVinit < 2.86-alt2 in sysvinit-utils

* Wed Mar 02 2011 Alexey Shabalin <shaba@altlinux.ru> 19-alt2.git20110301
- upstream snapshot 20110301

* Tue Mar 01 2011 Alexey Shabalin <shaba@altlinux.ru> 19-alt1
- v19
- add condstop, condreload for compatibility with ALTLinux

* Mon Feb 28 2011 Alexey Shabalin <shaba@altlinux.ru> 18-alt2.git20110225
- upstream snapshot 20110225
- modify altlinux-clock for run only when /etc/adjtime is missing, and use hwclock-load
- add support mount /proc with gid=proc
- add network.service

* Thu Feb 17 2011 Alexey Shabalin <shaba@altlinux.ru> 18-alt1
- v18

* Tue Feb 15 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt9.20110213
- add one altlinux-storage-init service (with altlinux-storage-init script) instead of altlinux-lvm, altlinux-multipath, altlinux-raid services

* Tue Feb 15 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt8.20110213
- fix run clock service
- add altlinux-swap service
- add altlinux-lvm, altlinux-multipath, altlinux-raid services

* Mon Feb 14 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt7.20110213
- adapt completion for bash3; thx to iv@
- add altlinux-clock service
- fix work with plymoth
- package dir /etc/modules-load.d and add example
- add quota services to local-fs.target
- build with libcryptsetup support

* Wed Feb 09 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt6.20110209
- upstream snapshot
- plymouth support
- drop multipath and evms services

* Mon Feb 07 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt5
- add multipath service
- add update_chrooted service
- add idetune service
- add evms service to git (but not install)

* Fri Feb 04 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt4
- add load legacy module configuration from /etc/modules
- use hwclock-load.service instead init.d/clock
- use systemd-random-seed-load.service instead init.d/random

* Thu Feb 03 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt3
- don't use sysinit
- fix symlink path for rc-local

* Tue Feb 01 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt2
- add prefdm service
- fix syslog name service
- add Before=sysinit.target to sysinit.service
- use mingetty instead of agetty

* Tue Jan 25 2011 Alexey Shabalin <shaba@altlinux.ru> 17-alt1
- version 17

* Fri Jan 14 2011 Alexey Shabalin <shaba@altlinux.ru> 16-alt1
- version 16

* Fri Nov 19 2010 Alexey Shabalin <shaba@altlinux.ru> 13-alt1
- version 13

* Sun Sep 19 2010 Alexey Shabalin <shaba@altlinux.ru> 10-alt1
- version 10 + snapshot Sep 22 2010

* Thu Sep 09 2010 Alexey Shabalin <shaba@altlinux.ru> 9-alt1
- version 9

* Thu Aug 26 2010 Alexey Shabalin <shaba@altlinux.ru> 8-alt1
- version 8
- build with libaudit

* Wed Aug 25 2010 Alexey Shabalin <shaba@altlinux.ru> 7-alt1
- version 7
- build with selinux

* Fri Jul 09 2010 Alexey Shabalin <shaba@altlinux.ru> 2-alt1
- version 2

* Wed Jul 07 2010 Alexey Shabalin <shaba@altlinux.ru> 1-alt1
- initial build for ALTLinux
